
QGIS Application - Bug report #9208

QGIS crashes when using addAttributes on any vector data provider

2013-12-12 04:09 AM - Giovanni Allegri

Status: Closed

Priority: High

Assignee:

Category: Data Provider

Affected QGIS version:2.0.1 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:Yes Copied to github as #: 17833

Description

During a course students with QGIS Dufour 64 bit (on Windows 7) reported crashes when using QgsVectorDataProvider::addAttributes()

method. It happens whatever provider we use.

QGIS receives an OS signal and generates the following minidump: 

https://dl.dropboxusercontent.com/u/13861666/qgis-20131212-123926-2704-6552-d94c044.dmp

The same code works fine on QGIS 32bit.

OS: Windows 7

QGIS 2.0.1 (both from OSGeo4W and Standalone)

commit:d94c044

Associated revisions

Revision 3e0badcb - 2015-10-17 10:03 PM - Jürgen Fischer

Fix sip conversion from QgsFields to QList<QgsField> (fixes #9208)

History

#1 - 2013-12-13 01:50 AM - Giovanni Manghi

- Priority changed from Normal to High

- Crashes QGIS or corrupts data changed from No to Yes

#2 - 2014-02-08 02:44 AM - Jürgen Fischer

- Subject changed from QGIS for Windows 64bit crashes when using addSttributes on any vector data provider to QGIS for Windows 64bit crashes 

when using addAttributes on any vector data provider

#3 - 2014-02-13 08:48 AM - Jürgen Fischer

- Status changed from Open to Feedback

Can you provide more detail?  Doesn't crash here.

#4 - 2014-02-14 01:42 AM - Giovanni Allegri

Here you can find a test shapefile [1] and a tiny test script [2]. I've just tested it with QGIS 64bit through the python console, on Windows 8, and it crashes.
http://qgis.org/api/classQgsVectorDataProvider.html#ac3d0927cff569c3b19b8be56cf1541c6
https://dl.dropboxusercontent.com/u/13861666/qgis-20131212-123926-2704-6552-d94c044.dmp


[1]https://dl.dropboxusercontent.com/u/13861666/qgis64_crash/a_polygon.zip

[2]https://dl.dropboxusercontent.com/u/13861666/qgis64_crash/test_dump.py

#5 - 2014-02-14 01:44 AM - Giovanni Allegri

PS: it's just a test. In general I do changes to the layers in an editing session. I just wanted to report two things:

    -  different behaviour between 32 bit and 64 bit. The first works fine.

    -  a crash shouldn't happen. In case it's an errroneus operation it should communicate it without crashing.

#6 - 2014-02-14 10:03 AM - Jürgen Fischer

Giovanni Allegri wrote:

Here you can find a test shapefile [1] and a tiny test script [2]. I've just tested it with QGIS 64bit through the python console, on Windows 8, and it

crashes.

[1]https://dl.dropboxusercontent.com/u/13861666/qgis64_crash/a_polygon.zip

[2]https://dl.dropboxusercontent.com/u/13861666/qgis64_crash/test_dump.py

um, I wonder why pr.addAttributes( origFields ) works at all - as it should be pr.addAttributes( origFields.toList() ).  That works.  So it's probably some

casting smartness going on that leads to the crash...

#7 - 2014-02-14 10:12 AM - Giovanni Allegri

I'm not expert with SIP. I thought QgsFields were automatically casted to lists by the SIP wrapper, but I see that getitem method is commented. [1]

It would more pythonic ig QgsFields were treated as lists without having to call the .toList() method.

[1] https://github.com/qgis/QGIS/blob/master/python/core/qgsfield.sip#L188

#8 - 2014-02-14 11:34 AM - Jürgen Fischer

- OS version deleted (64 bit)

- Operating System deleted (Windows)

Also reproducable on Linux

#9 - 2014-02-14 11:55 AM - Giovanni Allegri

It doesn't happen with QGIS 32bit on Windows (at least on my machine)

#10 - 2014-06-21 03:06 PM - Giovanni Manghi

- Subject changed from QGIS for Windows 64bit crashes when using addAttributes on any vector data provider to QGIS crashes when using 

addAttributes on any vector data provider

- Status changed from Feedback to Open

#11 - 2015-01-09 07:04 AM - Sandro Santilli
https://github.com/qgis/QGIS/blob/master/python/core/qgsfield.sip#L188


I don't know if this is the same bug but I got crashes when trying to add fields to either a PostGIS or a Spatialite table.

The crash happens when leaving "edit mode" right after saving the changes sent this error:

 Errors: SUCCESS: 3 attribute(s) added. ERROR: 8 attribute value change(s) not applied. 

   Provider errors:                                                             

       PostGIS error while changing attributes: ERROR:  syntax error at or near "WHERE" 

     LINE 1: UPDATE "public"."rotation_test" SET  WHERE ctid='(0,0)'            

                                                  ^                

#12 - 2015-01-09 07:05 AM - Sandro Santilli

If it is the same, this is happening in master, pre-2.8.0, on a 64bit linux

#13 - 2015-01-09 07:05 AM - Sandro Santilli

- Tag set to attributes

#14 - 2015-10-16 08:15 AM - Jürgen Fischer

- Status changed from Open to Feedback

#15 - 2015-10-16 08:18 AM - Jürgen Fischer

- File a_polygon.zip added

- File test_dump.py added

#16 - 2015-10-16 08:18 AM - Jürgen Fischer

- Status changed from Feedback to Open

#17 - 2015-10-16 08:19 AM - Jürgen Fischer

- File test_dump.py added

#18 - 2015-10-16 08:19 AM - Jürgen Fischer

- File deleted (test_dump.py)

#19 - 2015-10-17 01:03 PM - Jürgen Fischer

- Status changed from Open to Closed

Fixed in changeset commit:"3e0badcb550731a773050dddc210e71328246db3".

Files

a_polygon.zip 1.54 KB 2015-10-16 Jürgen Fischer

test_dump.py 348 Bytes 2015-10-16 Jürgen Fischer
